local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB

local CURRENT_PAGE = 0
local MAX_PAGE = 5

SLASH_TOHR1, SLASH_TOHR2, SLASH_TOHR3 = '/tui', '/tohr', '/tohrui';
function SlashCmdList.TOHR(msg, editbox)
	if msg == 'help' then
		 print('|cffffff00Tohr UI |cffffffffusage:');
		 print('/tui');
		 print('/tui reset');
		 print('/tui install');
		 print('/tui options');
	elseif msg == 'reset' then
		E:ResetUI()
	elseif msg == 'install' then
		E:Install();
	elseif msg == 'options' then
		E:Install();
	else
		E:Install();
	end
end

local function SetupChat()
	InstallStepComplete.message = L["Chat Set"]
	InstallStepComplete:Show()			
	FCF_ResetChatWindows()
	FCF_SetLocked(ChatFrame1, 1)
	FCF_DockFrame(ChatFrame2)
	FCF_SetLocked(ChatFrame2, 1)	
			
	for i = 1, NUM_CHAT_WINDOWS do
		local frame = _G[format("ChatFrame%s", i)]
		local chatFrameId = frame:GetID()
		local chatName = FCF_GetChatWindowInfo(chatFrameId)
		
		-- move general bottom left
		if i == 1 then
			frame:ClearAllPoints()
			frame:Point("BOTTOMLEFT", LeftChatToggleButton, "TOPLEFT", 1, 3)			
		elseif i == 3 then
			frame:ClearAllPoints()
			frame:Point("BOTTOMLEFT", RightChatDataPanel, "TOPLEFT", 1, 3)
		end
		
		FCF_SavePositionAndDimensions(frame)
		FCF_StopDragging(frame)
		
		-- set default Elvui font size
		FCF_SetChatWindowFontSize(nil, frame, 14, "OUTLINE")
		
		-- rename windows general because moved to chat #3
		if i == 1 then
			FCF_SetWindowName(frame, GENERAL)
		elseif i == 2 then
			FCF_SetWindowName(frame, GUILD_EVENT_LOG)
		end
	end
	
	ChatFrame_RemoveAllMessageGroups(ChatFrame1)
	ChatFrame_AddMessageGroup(ChatFrame1, "SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD")
	ChatFrame_AddMessageGroup(ChatFrame1, "OFFICER")
	ChatFrame_AddMessageGroup(ChatFrame1, "GUILD_ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_CONVERSATION")
	ChatFrame_AddMessageGroup(ChatFrame1, "BN_INLINE_TOAST_ALERT")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY")
	ChatFrame_AddMessageGroup(ChatFrame1, "PARTY_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "RAID_WARNING")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND")
	ChatFrame_AddMessageGroup(ChatFrame1, "BATTLEGROUND_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_HORDE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_ALLIANCE")
	ChatFrame_AddMessageGroup(ChatFrame1, "BG_NEUTRAL")
	ChatFrame_AddMessageGroup(ChatFrame1, "SYSTEM")
	ChatFrame_AddMessageGroup(ChatFrame1, "AFK")
	ChatFrame_AddMessageGroup(ChatFrame1, "DND")
	ChatFrame_AddMessageGroup(ChatFrame1, "IGNORED")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT")
	ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT_LEADER")
	ChatFrame_AddMessageGroup(ChatFrame1, "CHANNEL")	
	ChatFrame_AddMessageGroup(ChatFrame1, "EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "ACHIEVEMENT")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_SAY")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_YELL")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_BOSS_EMOTE")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONSTER_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "BOSS_WHISPER")
	ChatFrame_AddMessageGroup(ChatFrame1, "ERRORS")
	ChatFrame_AddMessageGroup(ChatFrame1, "LOOT")
	ChatFrame_AddMessageGroup(ChatFrame1, "MONEY")
	ChatFrame_AddMessageGroup(ChatFrame1, "SKILL")
	ChatFrame_AddMessageGroup(ChatFrame1, "CURRENCY ")
	ChatFrame_AddMessageGroup(ChatFrame1, "COMBAT_XP_GAIN")
	ChatFrame_RemoveChannel(ChatFrame1, L['LocalDefense'])
	ChatFrame_RemoveChannel(ChatFrame1, L['LookingForGroup'])

	-- enable classcolor automatically on login and on each character without doing /configure each time.
	ToggleChatColorNamesByClassGroup(true, "SAY")
	ToggleChatColorNamesByClassGroup(true, "EMOTE")
	ToggleChatColorNamesByClassGroup(true, "YELL")
	ToggleChatColorNamesByClassGroup(true, "GUILD")
	ToggleChatColorNamesByClassGroup(true, "OFFICER")
	ToggleChatColorNamesByClassGroup(true, "GUILD_ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "ACHIEVEMENT")
	ToggleChatColorNamesByClassGroup(true, "WHISPER")
	ToggleChatColorNamesByClassGroup(true, "PARTY")
	ToggleChatColorNamesByClassGroup(true, "PARTY_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID")
	ToggleChatColorNamesByClassGroup(true, "RAID_LEADER")
	ToggleChatColorNamesByClassGroup(true, "RAID_WARNING")
	ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND")
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT")	
	ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT_LEADER")	
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL1")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL2")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL3")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL4")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL5")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL6")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL7")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL8")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL9")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL10")
	ToggleChatColorNamesByClassGroup(true, "CHANNEL11")
	
	--Adjust Chat Colors
	--General
	ChangeChatColor("CHANNEL1", 195/255, 230/255, 232/255)
	--Trade
	ChangeChatColor("CHANNEL2", 232/255, 158/255, 121/255)
	--Local Defense
	ChangeChatColor("CHANNEL3", 232/255, 228/255, 121/255)
end

local function SetupCVars()
	SetCVar("alternateResourceText", 1)
	SetCVar("statusTextDisplay", "BOTH")
	SetCVar("nameplateMotion", 0)
	SetCVar("lootUnderMouse", 0)
	SetCVar("scriptErrors", 1)
	SetCVar("countdownForCooldowns", 1)
	SetCVar("trackQuestSorting", "proximity")
	SetCVar("profanityFilter", 0)
	SetCVar("spamFilter", 0)
	SetCVar("chatBubblesParty", 0)
	SetCVar("removeChatDelay", 1)
	SetCVar("chatStyle", "classic")
	SetCVar("wholeChatWindowClickable", 0)
	SetCVar("conversationMode", "inline")
	SetCVar("alwaysShowActionBars", 1)
	SetCVar("UnitNameNPC", 1)
	SetCVar("UnitNameForceHideMinus", 1)
	SetCVar("UnitNameEnemyPetName", 0)
	SetCVar("UnitNameFriendlyPetName", 0)
	SetCVar("UnitNameFriendlySpecialNPCName", 0)
	SetCVar("UnitNameGuildTitle", 0)
	SetCVar("PetMeleeDamage", 0)
	SetCVar("PetSpellDamage", 0)
	SetCVar("CombatHealing", 0)
	SetCVar("CombatHealingAbsorbTarget", 0)
	SetCVar("CombatHealingAbsorbSelf", 0)
	SetCVar("enableCombatText", 0)
	SetCVar("enablePetBattleCombatText", 0)
	SetCVar("fctCombatState", 1)
	SetCVar("fctLowManaHealth", 0)
	SetCVar("fctSpellMechanics", 1)
	SetCVar("xpBarText", 1)
	SetCVar("playerStatusText", 1)
	SetCVar("petStatusText", 1)
	SetCVar("targetStatusText", 1)
	SetCVar("statusTextDisplay", 0)
	SetCVar("showToastConversation", 0)
	SetCVar("showToastWindow", 0)
	SetCVar("cameraYawSmoothSpeed", 270)
	SetCVar("cameraView", 5)
	SetCVar("cameraSmoothStyle", 1)
	SetCVar("cameraDistanceMax", 50)
	SetCVar("cameraDistanceMaxFactor", 2)
	SetCVar("showTutorials", 0)
	SetCVar("showNPETutorials", 0)
	SetCVar("serviceTypeFilter", 2)
	SetCVar("talentFrameShown", 1)
	SetCVar("addFriendInfoShown", 1)
	SetCVar("pendingInviteInfoShown", 1)
	SetCVar("threatPlaySounds", 0)
	SetCVar("violenceLevel", 5)
	SetCVar("Outline", 3)
	SetCVar("autoLootDefault", 1)
	SetCVar("assistAttack", 1)
	SetCVar("displaySpellActivationOverlays", 0)
	SetCVar("minimapZoom", 1)
	SetCVar("minimapInsideZoom", 5)
	SetCVar("showPartyPets", 0)
	SetCVar("showArenaEnemyFrames", 0)
	SetCVar("showArenaEnemyPets", 0)
	SetCVar("showCastableBuffs", 1)
	SetCVar("nameplateShowEnemies", 1)
	SetCVar("nameplateShowEnemyGuardians", 0)
	SetCVar("nameplateShowEnemyTotems", 0)
	SetCVar("talentPointsSpent", 1)
	SetCVar("showTokenFrame", 1)
	SetCVar("threatWarning", 0)
	SetCVar("ShowClassColorInNameplate", 1)
	SetCVar("minimapTrackedInfov2", 181352)
	SetCVar("characterFrameCollapsed", 0)
	SetCVar("activeCUFProfile", "Primary")

	
	
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:SetValue('CTRL')
	InterfaceOptionsActionBarsPanelPickupActionKeyDropDown:RefreshValue()
	InstallStepComplete.message = L["CVars Set"]
	InstallStepComplete:Show()					
end	

function E:GetColor(r, b, g, a)	
	return { r = r, b = b, g = g, a = a }
end

function E:SetupTheme(theme, noDisplayMsg)
	local classColor = RAID_CLASS_COLORS[E.myclass]
	E.private.theme = theme
	if not E.db.movers then E.db.movers = {}; end
		if theme == "TohrUI" then
		InstallStepComplete.message = L["TohrUI Installed"]
		InstallStepComplete:Show()
	-- Movers
		E.db.movers["ElvUF_FocusCastbarMover"] = "TOPLEFTElvUIParentTOPLEFT383-4"
		E.db.movers["ElvUF_PlayerCastbarMover"] = "BOTTOMElvUIParentBOTTOM0400"
		E.db.movers["ElvUF_RaidMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT191645"
		E.db.movers["LeftChatMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT445"
		E.db.movers["GMMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-49845"
		E.db.movers["BuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-4-4"
		E.db.movers["TargetPowerBarMover"] = "TOPRIGHTElvUIParentTOPRIGHT-461-478"
		E.db.movers["BossButton"] = "BOTTOMElvUIParentBOTTOM-310410"
		E.db.movers["LootFrameMover"] = "TOPElvUIParentTOP298-100"
		E.db.movers["ElvUF_RaidpetMover"] = "TOPLEFTElvUIParentBOTTOMLEFT3831076"
		E.db.movers["ElvUF_FocusMover"] = "BOTTOMElvUIParentBOTTOM-180335"
		E.db.movers["ClassBarMover"] = "BOTTOMElvUIParentBOTTOM0310"
		E.db.movers["MicrobarMover"] = "BOTTOMElvUIParentBOTTOM-3104"
		E.db.movers["ElvUF_AssistMover"] = "TOPElvUIParentTOP-301-4"
		E.db.movers["ElvUF_Raid25Mover"] = "BOTTOMElvUIParentBOTTOM011"
		E.db.movers["ComboBarMover"] = "BOTTOMElvUIParentBOTTOM0388"
		E.db.movers["ExperienceBarMover"] = "TOPLEFTElvUIParentTOPLEFT5-145"
		E.db.movers["ElvUF_TargetTargetMover"] = "TOPRIGHTElvUIParentTOPRIGHT-367-501"
		E.db.movers["ElvUF_TargetMover"] = "TOPRIGHTElvUIParentTOPRIGHT-450-500"
		E.db.movers["ElvUF_PartyMover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT191645"
		E.db.movers["LossControlMover"] = "TOPElvUIParentTOP0-435"
		E.db.movers["ElvUF_Raid40Mover"] = "BOTTOMRIGHTElvUIParentBOTTOMLEFT11474"
		E.db.movers["TotemBarMover"] = "BOTTOMElvUIParentBOTTOM230338"
		E.db.movers["WatchFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-143-206"
		E.db.movers["ElvAB_1"] = "BOTTOMElvUIParentBOTTOM062"
		E.db.movers["CM_MOVER"] = "BOTTOMElvUIParentBOTTOM0389"
		E.db.movers["PlayerPowerBarMover"] = "BOTTOMElvUIParentBOTTOM0413"
		E.db.movers["ElvUF_PetMover"] = "BOTTOMElvUIParentBOTTOM-180365"
		E.db.movers["ElvAB_4"] = "BOTTOMElvUIParentBOTTOM091"
		E.db.movers["ReputationBarMover"] = "TOPLEFTElvUIParentTOPLEFT5-145"
		E.db.movers["AltPowerBarMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-525425"
		E.db.movers["ElvAB_3"] = "BOTTOMElvUIParentBOTTOM04"
		E.db.movers["ElvAB_5"] = "BOTTOMElvUIParentBOTTOM0320"
		E.db.movers["ArenaHeaderMover"] = "TOPLEFTElvUIParentTOPLEFT490-200"
		E.db.movers["VehicleSeatMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT49897"
		E.db.movers["ElvUF_Raid10Mover"] = "BOTTOMElvUIParentBOTTOM011"
		E.db.movers["ObjectiveFrameMover"] = "TOPRIGHTElvUIParentTOPRIGHT-122-194"
		E.db.movers["BNETMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT49845"
		E.db.movers["ShiftAB"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT44"
		E.db.movers["ElvUF_TargetCastbarMover"] = "BOTTOMElvUIParentBOTTOM0500"
		E.db.movers["PetAB"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-4369"
		E.db.movers["ElvAB_6"] = "TOPLEFTElvUIParentTOPLEFT383-4"
		E.db.movers["TooltipMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-455225"
		E.db.movers["ElvUF_TankMover"] = "TOPElvUIParentTOP-302-4"
		E.db.movers["BossHeaderMover"] = "BOTTOMLEFTElvUIParentBOTTOMLEFT4250"
		E.db.movers["ElvUF_PlayerMover"] = "BOTTOMElvUIParentBOTTOM0356"
		E.db.movers["ElvAB_2"] = "BOTTOMElvUIParentBOTTOM033"
		E.db.movers["RightChatMover"] = "BOTTOMRIGHTElvUIParentBOTTOMRIGHT-445"
		E.db.movers["AlertFrameMover"] = "TOPElvUIParentTOP305-100"
		E.db.movers["DebuffsMover"] = "TOPRIGHTElvUIParentTOPRIGHT-4-100"
		E.db.movers["MinimapMover"] = "TOPLEFTElvUIParentTOPLEFT4-4"
		
	-- General
		E.db.general.normTex = "TohrUI"
		E.db.general.glossTex = "TohrUI"
		E.db.general.dmgfont = "Tohr Combat"
		E.db.general.namefont = "Tohr Font"
		E.db.general.autoAcceptInvite = true
		E.db.general.font = "Tohr Font"
		E.db.general.topPanel = true
		E.db.general.bottomPanel = true
		E.db.general.fontSize = 11
		E.db.general.minimap.size = 135
		E.db.general.minimap.garrisonPos = "BOTTOMLEFT"
		E.db.general.minimap.icons.garrison.xOffset = -9
		E.db.general.minimap.icons.garrison.yOffset = -9
		E.db.general.minimap.icons.garrison.position = "BOTTOMLEFT"
		E.db.general.experience.width = 155
		E.db.general.experience.height = 15
		E.db.general.experience.mouseover = false
		E.db.general.experience.orientation = "HORIZONTAL"
		E.db.general.experience.textFormat = "PERCENT"
		E.db.general.experience.textSize = 12
		E.db.general.reputation.width = 155
		E.db.general.reputation.height = 15
		E.db.general.reputation.mouseover = true
		E.db.general.reputation.orientation = "HORIZONTAL"
		E.db.general.reputation.textFormat = "CURMAX"
		E.db.general.reputation.textSize = 12
		E.db.general.threat.enable = false
		E.db.general.backdropcolor = { r = 26/255,g = 26/255,b = 26/255 }
		E.db.general.backdropfadecolor = { r = 15/255,g = 15/255,b = 15/255, a = 0.80}
		E.db.general.valuecolor = E:GetColor(classColor.r, classColor.b, classColor.g)
		E.db.general.totems.enable = true
		E.db.general.totems.growthDirection = "HORIZONTAL"
		E.db.general.vendorGrays = true
		E.db.auras.disableBlizzard = true
	--Unit Frames
		E.db.unitframe.statusbar = "TohrUI"
		E.db.unitframe.font = "ElvUI Pixel"
		E.db.unitframe.fontSize = 10
		E.db.unitframe.fontOutline = "OUTLINE"
		E.db.unitframe.debuffHighlighting = false
		E.db.unitframe.smoothbars = true
		E.db.unitframe.colors.healthclass = false
		E.db.unitframe.colors.powerclass = true
		E.db.unitframe.colors.colorhealthbyvalue = false
		E.db.unitframe.colors.transparentHealth = true
		E.db.unitframe.colors.classbackdrop = true
		E.db.unitframe.colors.health = { r = 0/255, g = 0/255, b = 0/255 }
		E.db.unitframe.colors.health_backdrop = { r = 255/255,g = 255/255,b = 255/255 }
		E.db.unitframe.colors.tapped = { r = 231/255, g = 241/255, b = 255/255 }
		E.db.unitframe.colors.disconnected = { r = 255/255, g = 210/255, b = 158/255 }
		E.db.unitframe.colors.power.MANA = { r = 79/255,g = 115/255,b = 161/255 }
		E.db.unitframe.colors.power.RAGE = { r = 199/255,g = 64/255,b = 64/255 }
		E.db.unitframe.colors.power.FOCUS = { r = 181/255,g = 110/255,b = 69/255 }
		E.db.unitframe.colors.power.ENERGY = { r = 255/255,g = 234/255,b = 0/255 }
		E.db.unitframe.colors.power.RUNIC_POWER = { r = 0/255,g = 209/255,b = 255/255 }
		E.db.unitframe.colors.reaction.BAD = { r = 199/225, g = 64/225, b = 64/225 }
		E.db.unitframe.colors.reaction.NEUTRAL = { r = 218/255, g = 197/255, b = 92/255 }
		E.db.unitframe.colors.reaction.GOOD = { r = 75/255, g = 175/255, b = 76/255 }
		E.db.unitframe.colors.castClassColor = true
		E.db.unitframe.colors.transparentCastbar = true
		E.db.unitframe.colors.customhealthbackdrop = false
		E.db.unitframe.colors.colorhealthbyvalue = false
		E.db.unitframe.units.player.customTexts = {}
		E.db.unitframe.units.player.restIcon = true
		E.db.unitframe.units.player.width = 270
		E.db.unitframe.units.player.height = 30
		E.db.unitframe.units.player.healPrediction = false
		E.db.unitframe.units.player.threatStyle = "NONE"
		E.db.unitframe.units.player.health.text_format = ""
		E.db.unitframe.units.player.power.text_format = ""
		E.db.unitframe.units.player.power.height = 20
		E.db.unitframe.units.player.power.yOffset = 0
		E.db.unitframe.units.player.power.detachFromFrame = false
		E.db.unitframe.units.player.pvp.text_format = "|cFFB04F4F[pvptimer]|r"
		E.db.unitframe.units.player.buffs.enable = false
		E.db.unitframe.units.player.debuffs.enable = true
		E.db.unitframe.units.player.debuffs.sizeOverride = 48
		E.db.unitframe.units.player.debuffs.xOffset = -40
		E.db.unitframe.units.player.debuffs.yOffset = 195
		E.db.unitframe.units.player.debuffs.fontSize = 20
		E.db.unitframe.units.player.debuffs.attachTo = "Frame"
		E.db.unitframe.units.player.debuffs.anchorPoint = "LEFT"
		E.db.unitframe.units.player.debuffs.perrow = 6
		E.db.unitframe.units.player.debuffs.useFilter = "Blacklist"
		E.db.unitframe.units.player.castbar.enable = true
		E.db.unitframe.units.player.castbar.width = 270
		E.db.unitframe.units.player.castbar.height = 20
		E.db.unitframe.units.player.castbar.icon = true
		E.db.unitframe.units.player.castbar.latency = true
		E.db.unitframe.units.player.castbar.format = "Remaining"
		E.db.unitframe.units.player.castbar.ticks = true
		E.db.unitframe.units.player.castbar.spark = false
		E.db.unitframe.units.player.classbar.enable = true
		E.db.unitframe.units.player.classbar.detachFromFrame = true
		E.db.unitframe.units.player.classbar.detachedWidth = 270
		E.db.unitframe.units.player.classbar.height = 10
		E.db.unitframe.units.player.aurabar.enable = false
		E.db.unitframe.units.player.stagger.enable = false
		E.db.unitframe.units.target.rangeCheck = true
		E.db.unitframe.units.target.width = 270
		E.db.unitframe.units.target.height = 30
		E.db.unitframe.units.target.healPrediction = false
		E.db.unitframe.units.target.threatStyle = "NONE"
		E.db.unitframe.units.target.health.text_format = "[health:current-percent]"
		E.db.unitframe.units.target.health.position = "LEFT"
		E.db.unitframe.units.target.health.xOffset = 0
		E.db.unitframe.units.target.health.yOffset = 13
		E.db.unitframe.units.target.power.text_format = "[power:current]"
		E.db.unitframe.units.target.power.position = "RIGHT"
		E.db.unitframe.units.target.power.height = 5
		E.db.unitframe.units.target.power.xOffset = 0
		E.db.unitframe.units.target.power.yOffset = 13
		E.db.unitframe.units.target.power.detachFromFrame = false
		E.db.unitframe.units.target.power.hideonnpc = false
		E.db.unitframe.units.target.name.position = "CENTER"
		E.db.unitframe.units.target.name.text_format = "[namecolor][name:medium] [difficultycolor][smartlevel] [shortclassification]"
		E.db.unitframe.units.target.name.xOffset = 0
		E.db.unitframe.units.target.name.yOffset = 13
		E.db.unitframe.units.target.buffs.enable = true
		E.db.unitframe.units.target.buffs.anchorPoint = "LEFT"
		E.db.unitframe.units.target.buffs.fontSize = 10
		E.db.unitframe.units.target.buffs.xOffset = -2
		E.db.unitframe.units.target.buffs.yOffset = 0
		E.db.unitframe.units.target.buffs.perrow = 4
		E.db.unitframe.units.target.buffs.sizeOverride = 30
		E.db.unitframe.units.target.debuffs.enable = false
		E.db.unitframe.units.target.combobar.detachFromFrame = true
		E.db.unitframe.units.target.combobar.autoHide = false
		E.db.unitframe.units.target.combobar.detachedWidth = 270
		E.db.unitframe.units.target.combobar.height = 10
		E.db.unitframe.units.target.castbar.enable = true
		E.db.unitframe.units.target.castbar.width = 350
		E.db.unitframe.units.target.castbar.height = 20
		E.db.unitframe.units.target.castbar.icon = true
		E.db.unitframe.units.target.castbar.format = "Remaining"
		E.db.unitframe.units.target.castbar.spark = false
		E.db.unitframe.units.target.castbar.latency = true
		E.db.unitframe.units.target.aurabar.enable = false
		E.db.unitframe.units.targettarget.enable = true
		E.db.unitframe.units.targettarget.rangeCheck = true
		E.db.unitframe.units.targettarget.debuffs.enable = false
		E.db.unitframe.units.targettarget.width = 80
		E.db.unitframe.units.targettarget.height = 25
		E.db.unitframe.units.targettarget.power.enable = false
		E.db.unitframe.units.targettarget.name.position = "CENTER"
		E.db.unitframe.units.targettarget.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.targettarget.name.yOffset = 13
		E.db.unitframe.units.focus.rangeCheck = true
		E.db.unitframe.units.focus.width = 80
		E.db.unitframe.units.focus.height = 25
		E.db.unitframe.units.focus.power.enable = false
		E.db.unitframe.units.focus.threatStyle = "NONE"
		E.db.unitframe.units.focus.name.position = "CENTER"
		E.db.unitframe.units.focus.name.text_format = "[namecolor][name:short]"
		E.db.unitframe.units.focus.debuffs.enable = false
		E.db.unitframe.units.focus.castbar.enable = false
		E.db.unitframe.units.pet.width = 80
		E.db.unitframe.units.pet.height = 20
		E.db.unitframe.units.pet.threatStyle = "NONE"
		E.db.unitframe.units.pet.healPrediction = false
		E.db.unitframe.units.pet.power.enable = false
		E.db.unitframe.units.pet.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.pet.buffIndicator.enable = false
		E.db.unitframe.units.boss.enable = true
		E.db.unitframe.units.boss.width = 150
		E.db.unitframe.units.boss.height = 35
		E.db.unitframe.units.boss.health.text_format = "[healthcolor][health:percent]"
		E.db.unitframe.units.boss.health.position = "TOPRIGHT"
		E.db.unitframe.units.boss.power.enable = true
		E.db.unitframe.units.boss.power.position = "BOTTOM"
		E.db.unitframe.units.boss.power.yOffset = -8
		E.db.unitframe.units.boss.name.text_format = "[namecolor][name:short]"
		E.db.unitframe.units.boss.buffs.enable = false
		E.db.unitframe.units.boss.debuffs.enable = false
		E.db.unitframe.units.boss.castbar.enable = true
		E.db.unitframe.units.arena.width = 225
		E.db.unitframe.units.arena.height = 40
		E.db.unitframe.units.arena.health.text_format = "[health:current]"
		E.db.unitframe.units.arena.power.text_format = "[powercolor][power:current]"
		E.db.unitframe.units.arena.name.text_format = "[namecolor][name:medium]"
		E.db.unitframe.units.arena.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.arena.buffs.fontSize = 11
		E.db.unitframe.units.arena.buffs.sizeOverride = 18
		E.db.unitframe.units.arena.buffs.xOffset = 2
		E.db.unitframe.units.arena.buffs.yOffset = 10
		E.db.unitframe.units.arena.debuffs.fontSize = 11
		E.db.unitframe.units.arena.debuffs.sizeOverride = 18
		E.db.unitframe.units.arena.debuffs.xOffset = 2
		E.db.unitframe.units.arena.debuffs.yOffset = -10
		E.db.unitframe.units.arena.castbar.width = 225
		E.db.unitframe.units.arena.castbar.height = 10
		E.db.unitframe.units.arena.castbar.icon = false
		E.db.unitframe.units.arena.castbar.format = ""
		E.db.unitframe.units.arena.castbar.spark = false
		E.db.unitframe.units.party.width = 65
		E.db.unitframe.units.party.height = 45
		E.db.unitframe.units.party.threatStyle = "NONE"
		E.db.unitframe.units.party.growthDirection = "LEFT_UP"
		E.db.unitframe.units.party.horizontalSpacing = 4
		E.db.unitframe.units.party.verticalSpacing = 2
		E.db.unitframe.units.party.health.text_format = ""
		E.db.unitframe.units.party.power.enable = false
		E.db.unitframe.units.party.name.position = "CENTER"
		E.db.unitframe.units.party.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.party.debuffs.enable = false
		E.db.unitframe.units.party.GPSArrow.enable = false
		E.db.unitframe.units.party.buffIndicator.enable = false
		E.db.unitframe.units.party.roleIcon.enable = true
		E.db.unitframe.units.party.roleIcon.position = "TOPLEFT"
		E.db.unitframe.units.party.debuffs.perrow = 1
		E.db.unitframe.units.party.debuffs.numrows = 3
		E.db.unitframe.units.party.debuffs.sizeOverride = 30
		E.db.unitframe.units.party.debuffs.yOffset = -1
		E.db.unitframe.units.party.debuffs.anchorPoint = "BOTTOM"
		E.db.unitframe.units.party.debuffs.onlyDispellable = false
		E.db.unitframe.units.party.buffs.enable = false
		E.db.unitframe.units.party.buffs.perrow = 2
		E.db.unitframe.units.party.buffs.numrows = 1
		E.db.unitframe.units.party.buffs.sizeOverride = 20
		E.db.unitframe.units.party.buffs.xOffset = -47
		E.db.unitframe.units.party.buffs.yOffset = 0
		E.db.unitframe.units.party.buffs.anchorPoint = "RIGHT"
		E.db.unitframe.units.raid.horizontalSpacing = 2
		E.db.unitframe.units.raid.rdebuffs.enable = false
		E.db.unitframe.units.raid.growthDirection = "UP_LEFT"
		E.db.unitframe.units.raid.name.position = "CENTER"
		E.db.unitframe.units.raid.name.text_format = "[namecolor][name:veryshort]"
		E.db.unitframe.units.raid.power.enable = false
		E.db.unitframe.units.raid.buffIndicator.enable = false
		E.db.unitframe.units.raid.roleIcon.enable = false
		E.db.unitframe.units.raid.GPSArrow.enable = false
		E.db.unitframe.units.raid.width = 45
		E.db.unitframe.units.raid.height = 30
		E.db.unitframe.units.raid.health.text_format = ""
		E.db.unitframe.units.raid.threatStyle = "NONE"
		E.db.unitframe.units.raid.verticalSpacing = 2
		E.db.unitframe.units.raid.numGroups = 8
		E.db.unitframe.units.raid.visibility = "[@raid6,noexists][@raid6,exists] hide;show"
		E.db.unitframe.units.raid40.enable = false
		E.db.unitframe.units.tank.enable = false
		E.db.unitframe.units.assist.enable = false
	-- Bags
		E.db.bags.bagSize = 34
		E.db.bags.bankSize = 34
		E.db.bags.currencyFormat = "ICON"
		E.db.bags.sortInverted = false
	-- Nameplate
		E.db.nameplate.font = "ElvUI Pixel"
		E.db.nameplate.fontSize = 7
		E.db.nameplate.fontOutline = "OUTLINE"
		E.db.nameplate.targetIndicator = false
		E.db.nameplate.healthBar.width = 108
		E.db.nameplate.healthBar.height = 9
		E.db.nameplate.healthBar.text.enable = false
		E.db.nameplate.buffs.font = "ElvUI Pixel"
		E.db.nameplate.buffs.fontOutline = "OUTLINE"
		E.db.nameplate.debuffs.font = "ElvUI Pixel"
		E.db.nameplate.debuffs.fontOutline = "OUTLINE"
		E.db.nameplate.threat.goodColor = {r = 75/255, g = 175/255, b = 76/255}
		E.db.nameplate.threat.badColor = {r = 199/255, g = 64/255, b = 64/255}
		E.db.nameplate.threat.goodTransitionColor = {r = 218/255, g = 197/255, b = 92/255}
		E.db.nameplate.threat.badTransitionColor = {r = 240/255, g = 154/255, b = 17/255}
		E.db.nameplate.reactions.tapped = {r = 153/255, g = 153/255, b = 153/255}
		E.db.nameplate.reactions.friendlyNPC = { r = 79/255, g = 115/255, b = 161/255 }
		E.db.nameplate.reactions.friendlyPlayer = { r = 75/255, g = 175/255, b = 76/255 }
		E.db.nameplate.reactions.neutral = { r = 218/255, g = 197/255, b = 92/255 }
		E.db.nameplate.reactions.enemy = { r = 199/225, g = 64/225, b = 64/225 }
	-- Auras
		E.db.auras.font = "Tohr Font"
		E.db.auras.fontSize = 14
		E.db.auras.fontOutline = "OUTLINE"
		E.db.auras.consolidatedBuffs.enable = true
		E.db.auras.consolidatedBuffs.font = "Tohr Font"
		E.db.auras.consolidatedBuffs.fontSize = 10
		E.db.auras.consolidatedBuffs.fontOutline = "OUTLINE"
		E.db.auras.consolidatedBuffs.durations = false
		E.db.auras.buffs.wrapAfter = 12
		E.db.auras.buffs.maxWraps = 2
		E.db.auras.buffs.horizontalSpacing = 2
		E.db.auras.buffs.verticalSpacing = 16
		E.db.auras.buffs.size = 32
		E.db.auras.buffs.seperateOwn = 0
		E.db.auras.debuffs.horizontalSpacing = 3
		E.db.auras.debuffs.wrapAfter = 6
		E.db.auras.debuffs.seperateOwn = 0
		E.db.auras.debuffs.sortDir = "+"
		E.db.auras.debuffs.size = 32
	-- Chat
		E.db.chat.font = "ElvUI Font"
		E.db.chat.fontOutline = "OUTLINE"
		E.db.chat.emotionIcons = false
		E.db.chat.panelWidth = 492
		E.db.chat.panelHeight = 200
		E.db.chat.panelBackdrop = "HIDEBOTH"
		E.db.chat.panelTabBackdrop = false
		E.db.chat.tabFont = "ElvUI Pixel"
		E.db.chat.tabFontSize = 10
		E.db.chat.tabFontOutline = "OUTLINE"
		E.db.chat.lfgIcons = false
		E.db.chat.chatHistory = false
		E.db.chat.keywords = "%MYNAME%, ElvUI, TohrUI"
		E.db.chat.timeStampFormat = "%I:%M "
	-- Data Text
		E.db.datatexts.font = "Tohr Font"
		E.db.datatexts.fontSize = 10
		E.db.datatexts.fontOutline = "OUTLINE"
		E.db.datatexts.minimapPanels = false
		E.db.datatexts.leftChatPanel = false
		E.db.datatexts.rightChatPanel = false
		E.db.datatexts.panels.LeftChatDataPanel.left = ""
		E.db.datatexts.panels.LeftChatDataPanel.middle = ""
		E.db.datatexts.panels.LeftChatDataPanel.right = ""
		E.db.datatexts.panels.RightChatDataPanel.left = ""
		E.db.datatexts.panels.RightChatDataPanel.middle = ""
		E.db.datatexts.panels.RightChatDataPanel.right = ""
		E.db.datatexts.panels.LeftMiniPanel = ""
		E.db.datatexts.panels.RightMiniPanel = ""
		E.db.datatexts.battleground = false
	-- Tooltip
		E.db.tooltip.cursorAnchor = false
		E.db.tooltip.targetInfo = true
		E.db.tooltip.playerTitles = true
		E.db.tooltip.inspectInfo = false
		E.db.tooltip.guildRanks = false
		E.db.tooltip.talentInfo = false
		E.db.tooltip.itemCount = true
		E.db.tooltip.spellID = true
		E.db.tooltip.healthBar.height = 7
		E.db.tooltip.healthBar.font = "Tohr Font"
		E.db.tooltip.healthBar.text = true
		E.db.tooltip.healthBar.fontSize = 12
	-- Cooldown
		E.db.cooldown.threshold = 2
		E.db.cooldown.expiringcolor = { r = 255/255, g = 54/255, b = 54/255 }
		E.db.cooldown.secondscolor = { r = 156/255, g = 255/255, b = 123/255 }
		E.db.cooldown.minutescolor = { r = 1, g = 1, b = 1 }
		E.db.cooldown.hourscolor = { r = 102/225, g = 255/225, b = 255/225 }
		E.db.cooldown.dayscolor = { r = 102/225, g = 102/225, b = 255/225 }
	-- Actionbars
		E.db.actionbar.font = "ElvUI Pixel"
		E.db.actionbar.movementModifier = "CTRL"
		E.db.actionbar.fontSize = 10
		E.db.actionbar.fontOutline = "OUTLINE"
		E.db.actionbar.hotkeytext = true
		E.db.actionbar.noRangeColor = {r = 204/255, g = 26/255, b = 26/255}
		E.db.actionbar.noPowerColor = {r = 128/255, g = 128/255, b = 255/255}
		E.db.actionbar.microbar.enabled = false
		E.db.actionbar.microbar.mouseover = true
		E.db.actionbar.bar1.mouseover = false
		E.db.actionbar.bar1.buttons = 12
		E.db.actionbar.bar1.buttonsPerRow = 12
		E.db.actionbar.bar1.buttonsize = 26
		E.db.actionbar.bar1.buttonspacing = 2
		E.db.actionbar.bar1.backdrop = true
		E.db.actionbar.bar2.enabled = true
		E.db.actionbar.bar2.mouseover = false
		E.db.actionbar.bar2.buttons = 12
		E.db.actionbar.bar2.buttonsPerRow = 12
		E.db.actionbar.bar2.buttonsize = 26
		E.db.actionbar.bar2.buttonspacing = 2
		E.db.actionbar.bar2.backdrop = true
		E.db.actionbar.bar3.mouseover = true
		E.db.actionbar.bar3.buttons = 12
		E.db.actionbar.bar3.buttonsPerRow = 12
		E.db.actionbar.bar3.buttonsize = 26
		E.db.actionbar.bar3.buttonspacing = 2
		E.db.actionbar.bar3.backdrop = true
		E.db.actionbar.bar4.enabled = true
		E.db.actionbar.bar4.mouseover = true
		E.db.actionbar.bar4.buttons = 12
		E.db.actionbar.bar4.point = "BOTTOMLEFT"
		E.db.actionbar.bar4.buttonsPerRow = 12
		E.db.actionbar.bar4.backdrop = true
		E.db.actionbar.bar4.buttonsize = 26
		E.db.actionbar.bar4.buttonspacing = 2
		E.db.actionbar.bar5.mouseover = false
		E.db.actionbar.bar5.buttons = 8
		E.db.actionbar.bar5.buttonsPerRow = 12
		E.db.actionbar.bar5.buttonsize = 32
		E.db.actionbar.bar5.buttonspacing = 2
		E.db.actionbar.bar5.alpha = 0.8
		E.db.actionbar.bar6.enabled = false
		E.db.actionbar.bar6.buttons = 12
		E.db.actionbar.bar6.buttonsize = 26
		E.db.actionbar.bar6.buttonspacing = 2
		E.db.actionbar.barPet.mouseover = false
		E.db.actionbar.barPet.buttonsize = 32
		E.db.actionbar.barPet.buttonsPerRow = 1
		E.db.actionbar.barPet.buttonspacing = 2
		E.db.actionbar.stanceBar.mouseover = false
		E.db.actionbar.stanceBar.buttonsize = 35
		E.db.actionbar.stanceBar.buttonspacing = 2
	end
	
	if not noDisplayMsg then
		E:UpdateAll(true)
	end
end

function E:SetupAddon(addon)
	if addon == 'Skada' then
		if IsAddOnLoaded('Skada') then
			E:Print(L["The Default profile for Skada has been modified."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			SkadaDB['profiles']["Default"] = {
						["windows"] = {
							{
								["classicons"] = false,
								["barslocked"] = true,
								["background"] = {
									["borderthickness"] = 2,
									["color"] = {
										["a"] = 0,
										["b"] = 0.501960784313726,
									},
									["height"] = 122.999931335449,
									["texture"] = "None",
								},
								["y"] = -21.9993896484375,
								["barfont"] = "Tohr Font",
								["title"] = {
									["color"] = {
										["a"] = 0,
										["r"] = 0.486274509803922,
										["g"] = 0.486274509803922,
										["b"] = 0.486274509803922,
									},
									["font"] = "Tohr Font",
									["fontsize"] = 14,
									["height"] = 20,
									["fontflags"] = "OUTLINE",
									["texture"] = "TohrUI",
								},
								["barfontflags"] = "OUTLINE",
								["barcolor"] = {
									["a"] = 0.800000011920929,
									["r"] = 0.0588235294117647,
									["g"] = 0.0588235294117647,
									["b"] = 0.0588235294117647,
								},
								["point"] = "TOPLEFT",
								["buttons"] = {
									["mode"] = false,
								},
								["barwidth"] = 199,
								["barbgcolor"] = {
									["a"] = 0.800000011920929,
									["r"] = 0.0588235294117647,
									["g"] = 0.0588235294117647,
									["b"] = 0.0588235294117647,
								},
								["barfontsize"] = 12,
								["mode"] = "Damage",
								["bartexture"] = "TohrUI",
								["x"] = 161.000045776367,
							}, -- [1]
						},
						["icon"] = {
							["hide"] = true,
						},
						["showranks"] = false,
						["tooltippos"] = "topright",
					}
		else
			E:Print(L["The AddOn Skada is not enabled. Profile not created."])
		end
		
		if IsAddOnLoaded('SLDataText') then
			E:Print(L["A profile for SLDataText has been created. Copy from the |cffffff00Tohr UI|r profile."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			SLDTDB = {
			["profiles"] = {
				["TohrUI"] = {
				["namespaces"] = {
				["Bag"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["strata"] = "MEDIUM",
							["anch"] = "SLDT_Armor",
							["aF"] = "LEFT",
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["gfont"] = false,
							["textDisplay"] = "Bags: [R]/[T]",
							["forceShow"] = true,
							["enabled"] = false,
							["font"] = "Tohr Font",
							["fontSize"] = 20,
						},
					},
				},
				["Exp"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["strata"] = "MEDIUM",
							["anch"] = "SLDT_Bag",
							["gfont"] = false,
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["aF"] = "LEFT",
							["forceShow"] = true,
							["enabled"] = false,
							["font"] = "Tohr Font",
							["fontSize"] = 20,
						},
					},
				},
				["Reputation"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["strata"] = "MEDIUM",
							["anch"] = "SLDT_Currency",
							["aF"] = "LEFT",
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["gfont"] = false,
							["forceShow"] = true,
							["enabled"] = false,
							["font"] = "Tohr Font",
							["fontSize"] = 20,
						},
					},
				},
				["FPS"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["strata"] = "MEDIUM",
							["anch"] = "SLDT_Clock",
							["gfont"] = false,
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["aF"] = "LEFT",
							["font"] = "Tohr Font",
							["fontSize"] = 20,
							["forceShow"] = true,
						},
					},
				},
				["Latency"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["strata"] = "MEDIUM",
							["anch"] = "SLDT_Memory",
							["gfont"] = false,
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["aF"] = "LEFT",
							["font"] = "Tohr Font",
							["fontSize"] = 20,
							["forceShow"] = true,
						},
					},
				},
				["Coords"] = {
					["profiles"] = {
						["TohrUI"] = {
							["enabled"] = false,
						},
					},
				},
				["Memory"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["fontSize"] = 20,
							["anch"] = "SLDT_FPS",
							["gfont"] = false,
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["aF"] = "LEFT",
							["font"] = "Tohr Font",
							["forceShow"] = true,
						},
					},
				},
				["Mail"] = {
					["profiles"] = {
						["TohrUI"] = {
							["enabled"] = false,
							["fontSize"] = 20,
							["anch"] = "SLDT_Latency",
							["aF"] = "LEFT",
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["font"] = "Tohr Font",
							["showText"] = false,
							["gfont"] = false,
							["strata"] = "MEDIUM",
							["xOff"] = "-10",
						},
					},
				},
				["Gold"] = {
					["profiles"] = {
						["TohrUI"] = {
							["enabled"] = false,
							["strata"] = "MEDIUM",
							["anch"] = "SLDT_Mail",
							["aF"] = "LEFT",
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["gfont"] = false,
							["forceShow"] = true,
							["font"] = "Tohr Font",
							["fontSize"] = 20,
						},
					},
				},
				["Clock"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["fontSize"] = 20,
							["anch"] = "UIParent",
							["format24"] = false,
							["aF"] = "BOTTOMRIGHT",
							["aP"] = "RIGHT",
							["showPVP"] = false,
							["xOff"] = "-10",
							["gfont"] = false,
							["yOff"] = "20",
							["font"] = "Tohr Font",
						},
					},
				},
				["Armor"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["fontSize"] = 20,
							["enabled"] = false,
							["anch"] = "SLDT_Gold",
							["gfont"] = true,
							["aF"] = "LEFT",
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["textDisplay"] = "Armor: [Dur]%",
							["usegfunds"] = true,
							["strata"] = "MEDIUM",
							["forceShow"] = true,
							["font"] = "Tohr Font",
							["autorepair"] = true,
						},
					},
				},
				["Currency"] = {
					["profiles"] = {
						["TohrUI"] = {
							["outline"] = true,
							["strata"] = "MEDIUM",
							["anch"] = "SLDT_Exp",
							["aF"] = "LEFT",
							["aP"] = "RIGHT",
							["yOff"] = "0",
							["xOff"] = "-10",
							["gfont"] = false,
							["forceShow"] = true,
							["enabled"] = false,
							["font"] = "Tohr Font",
							["fontSize"] = 20,
						},
					},
				},
				["ZoneText"] = {
					["profiles"] = {
						["TohrUI"] = {
							["enabled"] = false,
							["forceShow"] = false,
						},
					},
				},
				},
				},
			},	
		["namespaces"] = {
			["Bag"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["strata"] = "MEDIUM",
					["anch"] = "SLDT_Armor",
					["aF"] = "LEFT",
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["gfont"] = false,
					["textDisplay"] = "Bags: [R]/[T]",
					["forceShow"] = true,
					["enabled"] = false,
					["font"] = "Tohr Font",
					["fontSize"] = 20,
				},
			},
			},
			["Exp"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["strata"] = "MEDIUM",
					["anch"] = "SLDT_Bag",
					["gfont"] = false,
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["aF"] = "LEFT",
					["forceShow"] = true,
					["enabled"] = false,
					["font"] = "Tohr Font",
					["fontSize"] = 20,
				},
			},
			},
			["Reputation"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["strata"] = "MEDIUM",
					["anch"] = "SLDT_Currency",
					["aF"] = "LEFT",
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["gfont"] = false,
					["forceShow"] = true,
					["enabled"] = false,
					["font"] = "Tohr Font",
					["fontSize"] = 20,
				},
			},
			},
			["FPS"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["strata"] = "MEDIUM",
					["anch"] = "SLDT_Clock",
					["gfont"] = false,
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["aF"] = "LEFT",
					["font"] = "Tohr Font",
					["fontSize"] = 20,
					["forceShow"] = true,
				},
			},
			},
			["Latency"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["strata"] = "MEDIUM",
					["anch"] = "SLDT_Memory",
					["gfont"] = false,
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["aF"] = "LEFT",
					["font"] = "Tohr Font",
					["fontSize"] = 20,
					["forceShow"] = true,
				},
			},
			},
			["Coords"] = {
			["profiles"] = {
				["TohrUI"] = {
					["enabled"] = false,
				},
			},
			},
			["Currency"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["strata"] = "MEDIUM",
					["anch"] = "SLDT_Exp",
					["aF"] = "LEFT",
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["gfont"] = false,
					["forceShow"] = true,
					["enabled"] = false,
					["font"] = "Tohr Font",
					["fontSize"] = 20,
				},
			},
			},
			["Clock"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["fontSize"] = 20,
					["anch"] = "UIParent",
					["format24"] = false,
					["aF"] = "BOTTOMRIGHT",
					["aP"] = "RIGHT",
					["showPVP"] = false,
					["xOff"] = "-10",
					["gfont"] = false,
					["yOff"] = "20",
					["font"] = "Tohr Font",
				},
			},
			},
			["Gold"] = {
			["profiles"] = {
				["TohrUI"] = {
					["enabled"] = false,
					["strata"] = "MEDIUM",
					["anch"] = "SLDT_Mail",
					["aF"] = "LEFT",
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["gfont"] = false,
					["forceShow"] = true,
					["font"] = "Tohr Font",
					["fontSize"] = 20,
				},
			},
			},
			["Armor"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["fontSize"] = 20,
					["enabled"] = false,
					["anch"] = "SLDT_Gold",
					["aF"] = "LEFT",
					["gfont"] = true,
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["font"] = "Tohr Font",
					["usegfunds"] = true,
					["textDisplay"] = "Armor: [Dur]%",
					["strata"] = "MEDIUM",
					["forceShow"] = true,
					["xOff"] = "-10",
					["autorepair"] = true,
				},
			},
			},
			["Mail"] = {
			["profiles"] = {
				["TohrUI"] = {
					["enabled"] = false,
					["fontSize"] = 20,
					["anch"] = "SLDT_Latency",
					["aF"] = "LEFT",
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["font"] = "Tohr Font",
					["showText"] = false,
					["gfont"] = false,
					["strata"] = "MEDIUM",
					["xOff"] = "-10",
				},
			},
			},
			["Memory"] = {
			["profiles"] = {
				["TohrUI"] = {
					["outline"] = true,
					["fontSize"] = 20,
					["anch"] = "SLDT_FPS",
					["gfont"] = false,
					["aP"] = "RIGHT",
					["yOff"] = "0",
					["xOff"] = "-10",
					["aF"] = "LEFT",
					["font"] = "Tohr Font",
					["forceShow"] = true,
				},
			},
			},
			["ZoneText"] = {
			["profiles"] = {
				["TohrUI"] = {
					["enabled"] = false,
					["forceShow"] = false,
				},
			},
			},
		},
			}
		else
			E:Print(L["The AddOn SLDataText is not enabled."])
		end
		
		if IsAddOnLoaded('BigWigs') then
			E:Print(L["The Default profile for BigWigs has been modified."])
			InstallStepComplete.message = L["AddOn profiles installed"]
			InstallStepComplete:Show()
			BigWigs3DB = {
	["namespaces"] = {
		["BigWigs_Plugins_Colors"] = {
		},
		["BigWigs_Plugins_Raid Icons"] = {
		},
		["LibDualSpec-1.0"] = {
		},
		["BigWigs_Plugins_Bars"] = {
			["profiles"] = {
				["Default"] = {
					["BigWigsEmphasizeAnchor_y"] = 432.866677148268,
					["fontSize"] = 13,
					["BigWigsAnchor_y"] = 192.711050673324,
					["emphasizeGrowup"] = true,
					["BigWigsAnchor_x"] = 127.288761762775,
					["texture"] = "TohrUI",
					["barStyle"] = "ElvUI",
					["BigWigsAnchor_width"] = 187.000213623047,
					["BigWigsEmphasizeAnchor_width"] = 242.999969482422,
					["BigWigsEmphasizeAnchor_x"] = 871.82345861067,
					["font"] = "Tohr Font",
					["outline"] = "OUTLINE",
					["emphasizeScale"] = 1.2,
				},
			},
		},
		["BigWigs_Plugins_Super Emphasize"] = {
			["profiles"] = {
				["Default"] = {
					["font"] = "Friz Quadrata TT",
				},
			},
		},
		["BigWigs_Plugins_Sounds"] = {
			["profiles"] = {
				["Default"] = {
					["Long"] = {
					},
					["Warning"] = {
					},
					["Info"] = {
					},
					["Alarm"] = {
					},
					["Alert"] = {
					},
				},
			},
		},
		["BigWigs_Plugins_Statistics"] = {
		},
		["BigWigs_Plugins_Messages"] = {
			["profiles"] = {
				["Default"] = {
					["outline"] = "OUTLINE",
					["BWEmphasizeMessageAnchor_x"] = 609.422280381787,
					["BWEmphasizeCountdownMessageAnchor_x"] = 562.489119523107,
					["chat"] = false,
					["BWEmphasizeMessageAnchor_y"] = 535.466375813212,
					["BWMessageAnchor_y"] = 535.466506021548,
					["sink20OutputSink"] = "BigWigsEmphasized",
					["BWMessageAnchor_x"] = 609.421716145662,
					["BWEmphasizeCountdownMessageAnchor_y"] = 410.310990838207,
					["font"] = "Tohr Font",
					["fontSize"] = 20.000000273549,
				},
			},
		},
		["BigWigs_Plugins_Alt Power"] = {
			["profiles"] = {
				["Default"] = {
					["posx"] = 1193.95591919313,
					["fontSize"] = 11.999999726451,
					["disabled"] = true,
					["posy"] = 289.422569014691,
					["fontOutline"] = "",
					["font"] = "Tohr Font",
				},
			},
		},
		["BigWigs_Plugins_Proximity"] = {
			["profiles"] = {
				["Default"] = {
					["soundDelay"] = 10,
					["fontSize"] = 20.000000273549,
					["disabled"] = true,
					["posx"] = 354.844387932617,
					["width"] = 100.000027628445,
					["objects"] = {
						["title"] = false,
						["close"] = false,
						["ability"] = false,
						["tooltip"] = false,
						["background"] = false,
					},
					["font"] = "ElvUI Font",
					["lock"] = true,
					["height"] = 95.9998665081086,
					["posy"] = 524.799535277143,
				},
			},
		},
	},
	["profileKeys"] = {
		["Trezz - Zul'jin"] = "Default",
		["Positohr - Zul'jin"] = "Default",
		["Tohrr - Zul'jin"] = "Default",
		["Tohr - Zul'jin"] = "Default",
		["Tohrible - Zul'jin"] = "Default",
	},
	["global"] = {
		["watchedMovies"] = {
			["953:12"] = true,
			["953:2"] = true,
			["953:9"] = true,
			["953:8"] = true,
		},
	},
	["profiles"] = {
		["Default"] = {
			["raidicon"] = false,
		},
	},
}
			BigWigs3IconDB = {
					["hide"] = true,
				}
		else
			E:Print(L["The AddOn BigWigs is not enabled. Profile not created."])
		end		
	end
end

local function InstallComplete()
	E.private.install_complete = E.version
	
	if GetCVarBool("Sound_EnableMusic") then
		StopMusic()
	end
	
	ReloadUI()
end
		
local function ResetAll()
	InstallNextButton:Disable()
	InstallPrevButton:Disable()
	InstallOption1Button:Hide()
	InstallOption1Button:SetScript("OnClick", nil)
	InstallOption1Button:SetText("")
	InstallOption2Button:Hide()
	InstallOption2Button:SetScript('OnClick', nil)
	InstallOption2Button:SetText('')
	InstallOption3Button:Hide()
	InstallOption3Button:SetScript('OnClick', nil)
	InstallOption3Button:SetText('')	
	InstallOption4Button:Hide()
	InstallOption4Button:SetScript('OnClick', nil)
	InstallOption4Button:SetText('')
	InstallOption5Button:Hide()
	InstallOption5Button:SetScript('OnClick', nil)
	InstallOption5Button:SetText('')
	InstallOption6Button:Hide()
	InstallOption6Button:SetScript('OnClick', nil)
	InstallOption6Button:SetText('')
	InstallOption7Button:Hide()
	InstallOption7Button:SetScript('OnClick', nil)
	InstallOption7Button:SetText('')
	InstallOption8Button:Hide()
	InstallOption8Button:SetScript('OnClick', nil)
	InstallOption8Button:SetText('')
	InstallOption9Button:Hide()
	InstallOption9Button:SetScript('OnClick', nil)
	InstallOption9Button:SetText('')
	InstallOption10Button:Hide()
	InstallOption10Button:SetScript('OnClick', nil)
	InstallOption10Button:SetText('')
	InstallOption11Button:Hide()
	InstallOption11Button:SetScript('OnClick', nil)
	InstallOption11Button:SetText('')
	InstallOption12Button:Hide()
	InstallOption12Button:SetScript('OnClick', nil)
	InstallOption12Button:SetText('')
	ElvUIInstallFrame:Size(206, 150)
	ElvUIInstallFrame:SetAlpha(0.6)
end

local function SetPage(PageNum)
	CURRENT_PAGE = PageNum
	ResetAll()
	
	local f = ElvUIInstallFrame
	
	if PageNum == 3 then
		InstallNextButton:Hide()
		InstallNextButton:Disable()
		InstallPrevButton:Enable()
		f.tutorialImage3:Hide()	
	else
		f.tutorialImage3:Show()
		InstallNextButton:Show()
		InstallNextButton:Enable()
	end
	
	if PageNum == 1 then
		InstallPrevButton:Hide()
		InstallPrevButton:Disable()
		f.tutorialImage2:Hide()	
	else
		f.tutorialImage2:Show()	
		InstallPrevButton:Show()
		InstallPrevButton:Enable()
	end
	

	if PageNum == 1 then
		InstallOption8Button:Show()
		InstallOption8Button:SetScript('OnClick', function() E:SetupTheme('TohrUI') end)
		InstallOption8Button:SetText(L['|cffffffffInstall UI|r'])
	elseif PageNum == 2 then
		InstallOption8Button:Show()
		InstallOption8Button:SetScript("OnClick", SetupChat)
		InstallOption8Button:SetText(L["|cffffffffChat Settings"])
		InstallOption9Button:Show()
		InstallOption9Button:SetScript("OnClick", SetupCVars)
		InstallOption9Button:SetText(L["|cffffffffInterface Settings"])
		InstallOption12Button:Show()
		InstallOption12Button:SetScript("OnClick", function() E:SetupAddon('Skada') end)
		InstallOption12Button:SetText(L["|cffffffffAddOn Settings"])
	elseif PageNum == 3 then
		InstallOption8Button:Show()
		InstallOption8Button:SetScript("OnClick", InstallComplete)
		InstallOption8Button:SetText(L["|cffffffffFinish"])
	end
end

local function NextPage()	
	if CURRENT_PAGE ~= MAX_PAGE then
		CURRENT_PAGE = CURRENT_PAGE + 1
		SetPage(CURRENT_PAGE)
	end
end

local function PreviousPage()
	if CURRENT_PAGE ~= 1 then
		CURRENT_PAGE = CURRENT_PAGE - 1
		SetPage(CURRENT_PAGE)
	end
end

--Install UI
function E:Install()	
	if not InstallStepComplete then
		local imsg = CreateFrame("Frame", "InstallStepComplete", E.UIParent)
		imsg:Size(206, 150)
		imsg:Point("TOP", 0, -100)
		imsg:Hide()
		imsg:SetScript('OnShow', function(self)
			if self.message then 
				PlaySoundFile([[Sound\Interface\LevelUp.wav]])
				self.text:SetText(self.message)
				UIFrameFadeOut(self, 3.5, 1, 0)
				E:Delay(4, function() self:Hide() end)	
				self.message = nil
			else
				self:Hide()
			end
		end)

		imsg.firstShow = false

		imsg.bg = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.bg:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.bg:SetPoint('BOTTOM')
		imsg.bg:Size(206, 150)
		imsg.bg:SetTexCoord(0.00195313, 0.63867188, 0.03710938, 0.23828125)
		imsg.bg:SetVertexColor(1, 1, 1, 0.6)


		imsg.lineBottom = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.lineBottom:SetDrawLayer('BACKGROUND', 2)
		imsg.lineBottom:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.lineBottom:SetPoint("BOTTOM")
		imsg.lineBottom:Size(206, 150)
		imsg.lineBottom:SetTexCoord(0.00195313, 0.81835938, 0.01953125, 0.03320313)

		imsg.text = imsg:CreateFontString(nil, 'ARTWORK', 'GameFont_Gigantic')
		imsg.text:Point("BOTTOM", 0, 12)
		imsg.text:SetTextColor(1, 0.82, 0)
		imsg.text:SetJustifyH("CENTER")
		
	end

	--Create Frame
	if not ElvUIInstallFrame then
		local f = CreateFrame("Button", "ElvUIInstallFrame", E.UIParent)
		f.SetPage = SetPage
		f:Size(206, 150)
		f:SetTemplate("Transparent")
		f:SetPoint("CENTER", 0, 150)
		f:SetFrameStrata('TOOLTIP')
		
		f.Next = CreateFrame("Button", "InstallNextButton", f, "UIPanelButtonTemplate")
		f.Next:StripTextures()
		f.Next:SetTemplate("Default", true)
		f.Next:SetAlpha(0)
		f.Next:Size(102, 30)
		f.Next:Point("RIGHT", 100, 0)
		f.Next:Disable()
		f.Next:SetScript("OnClick", NextPage)
		E.Skins:HandleButton(f.Next, true)
		
		f.Prev = CreateFrame("Button", "InstallPrevButton", f, "UIPanelButtonTemplate")
		f.Prev:StripTextures()
		f.Prev:SetTemplate("Default", true)
		f.Prev:SetAlpha(0)
		f.Prev:Size(100, 30)
		f.Prev:Point("LEFT", -102, 0)
		f.Prev:Disable()
		f.Prev:SetScript("OnClick", PreviousPage)
		E.Skins:HandleButton(f.Prev, true)
		
		f.Option1 = CreateFrame("Button", "InstallOption1Button", f, "UIPanelButtonTemplate")
		f.Option1:StripTextures()
		f.Option1:Size(100, 30)
		f.Option1:Point("BOTTOMLEFT", 2, 2)
		f.Option1:SetText("")
		f.Option1:Hide()
		E.Skins:HandleButton(f.Option1, true)
		
		f.Option2 = CreateFrame("Button", "InstallOption2Button", f, "UIPanelButtonTemplate")
		f.Option2:StripTextures()
		f.Option2:Size(100, 30)
		f.Option2:Point('BOTTOMRIGHT', -2, 2)
		f.Option2:SetText("")
		f.Option2:Hide()
		E.Skins:HandleButton(f.Option2, true)		
		
		f.Option3 = CreateFrame("Button", "InstallOption3Button", f, "UIPanelButtonTemplate")
		f.Option3:StripTextures()
		f.Option3:Size(100, 30)
		f.Option3:Point('BOTTOMLEFT', 2, 33)
		f.Option3:SetText("")
		f.Option3:Hide()
		E.Skins:HandleButton(f.Option3, true)	
		
		f.Option4 = CreateFrame("Button", "InstallOption4Button", f, "UIPanelButtonTemplate")
		f.Option4:StripTextures()
		f.Option4:Size(100, 30)
		f.Option4:Point("BOTTOMRIGHT", -2, 33)
		f.Option4:SetText("")
		E.Skins:HandleButton(f.Option4, true)
		
		f.Option5 = CreateFrame("Button", "InstallOption5Button", f, "UIPanelButtonTemplate")
		f.Option5:StripTextures()
		f.Option5:Size(100, 30)
		f.Option5:Point("BOTTOMLEFT", 2, 64)
		f.Option5:SetText("")
		E.Skins:HandleButton(f.Option5, true)
		
		f.Option6 = CreateFrame("Button", "InstallOption6Button", f, "UIPanelButtonTemplate")
		f.Option6:StripTextures()
		f.Option6:Size(100, 30)
		f.Option6:Point("BOTTOMRIGHT", -2, 64)
		f.Option6:SetText("")
		E.Skins:HandleButton(f.Option6, true)
		
		f.Option7 = CreateFrame("Button", "InstallOption7Button", f, "UIPanelButtonTemplate")
		f.Option7:StripTextures()
		f.Option7:SetAlpha(0)
		f.Option7:Size(100, 30)
		f.Option7:Point("BOTTOM", 0, -31)
		f.Option7:SetText("")
		E.Skins:HandleButton(f.Option7, true)
		
		f.Option8 = CreateFrame("Button", "InstallOption8Button", f, "UIPanelButtonTemplate")
		f.Option8:StripTextures()
		f.Option8:Size(100, 30)
		f.Option8:Point("CENTER", 0, -27)
		f.Option8:SetText("")
		E.Skins:HandleButton(f.Option8, true)
		
		f.Option9 = CreateFrame("Button", "InstallOption9Button", f, "UIPanelButtonTemplate")
		f.Option9:StripTextures()
		f.Option9:Size(100, 30)
		f.Option9:Point("CENTER", 0, 4)
		f.Option9:SetText("")
		E.Skins:HandleButton(f.Option9, true)
		
		f.Option10 = CreateFrame("Button", "InstallOption10Button", f, "UIPanelButtonTemplate")
		f.Option10:StripTextures()
		f.Option10:Size(100, 30)
		f.Option10:Point("BOTTOMLEFT", 2, 95)
		f.Option10:SetText("")
		E.Skins:HandleButton(f.Option10, true)
		
		f.Option11 = CreateFrame("Button", "InstallOption11Button", f, "UIPanelButtonTemplate")
		f.Option11:StripTextures()
		f.Option11:Size(100, 30)
		f.Option11:Point("BOTTOMRIGHT", -2, 95)
		f.Option11:SetText("")
		E.Skins:HandleButton(f.Option11, true)
		
		f.Option12 = CreateFrame("Button", "InstallOption12Button", f, "UIPanelButtonTemplate")
		f.Option12:StripTextures()
		f.Option12:Size(100, 30)
		f.Option12:Point("Bottom", 0, 2)
		f.Option12:SetText("")
		E.Skins:HandleButton(f.Option12, true)

		
		local close = CreateFrame("Button", "InstallCloseButton", f, "UIPanelCloseButton")
		close:Point("TOPRIGHT", f, "TOPRIGHT", -6, -6)
		close:SetScript("OnClick", function()
			f:Hide()
		end)		
		InstallCloseButton:SetAlpha(0)
		E.Skins:HandleCloseButton(close)

		f.tutorialImage = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\TohrUI2.tga')
		f.tutorialImage:Point('TOP', 0, 18)
		
		f.tutorialImage2 = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage2:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\arrowLeft.tga')
		f.tutorialImage2:Point('LEFT', "ElvUIInstallFrame", -35, 0)
		
		f.tutorialImage3 = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage3:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\arrowRight.tga')
		f.tutorialImage3:Point('RIGHT', "ElvUIInstallFrame", 35, 0)
		
		f.tutorialImage4 = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage4:SetTexture('Interface\\AddOns\\ElvUI_TohrUI\\media\\textures\\close.tga')
		f.tutorialImage4:Point("TOPRIGHT", f, "TOPRIGHT", -6, -6)

	end
	
	ElvUIInstallFrame:Show()
	NextPage()
end